
			include "propeller.i"
			include "demo.i"

			org	0

			long	3[256]

codestart
			mov	0, PAR		wz nr
		if_nz	sub	p_pre, #1
		if_nz	add	p_post, #1
		'if_nz   jmp 0 ' HAXXX
			mov vcfg_testpin,#%0100_0000
		if_z    mov measurecolor,#$7B
		if_nz    mov measurecolor,#$FB
			rdlong	sync, =@nextvbl

			' Set up NTSC video on P12-P14
		

			mov	VCFG, =%0_11_1_11_000_00000000000_001_0_00000000

			
			mov	VSCL, #15
			movi    FRQA,#$020
			mov count,#511
			movi	CTRA, #%00001_111
:fuzz		
			xor CTRA,ctra_fiddlebit
			add PHSA,CNT ' Random number
			add FRQA,CNT
			xor CTRA,ctra_fiddlebit
			movi    FRQA,#$020
			waitvid 0,0
			djnz count,#:fuzz
			mov CTRA,#0
			
			mov	VSCL, #1
			
			mov PHSA, #0
			mov	FRQA, ntsc_frq
			
			waitcnt	sync, =$30000		' Sync cogs, add 1 ms to sync variable
			' Enable PLLs simultaneously in both cogs
			movi	CTRA, #%0_00001_110_00000000_000000_000_000000 >> 23
			waitcnt	sync, =$18192			' Wait for PLL stabilization
			mov	VSCL, #257
			mov	DIRA, =$0000_7100 
			mov linesync,sync
			
			' Output test signal to measure phase offset
			or VCFG,vcfg_pinmask
			mov	VSCL, #256
:testsignal	waitvid measurecolor,#0
			mov CTRB,=((%10101_000<<23)+(14))
			mov FRQB,#1
			mov PHSB,#0 
			waitvid measurecolor,#0
			nop
			mov r1,PHSB
			cmp r1,#$1 wc wz
	if_be 	jmp #field
			mov	0, PAR		wz nr
	if_nz	jmp #field
			cogid r1
			lockset r1
:deathrow	jmp #:deathrow

field		
			
			call #hsync

			mov	VSCL, vscl_blank
			waitvid	metapixels, q1s
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #%%0

			call #hsync
			mov	VSCL, vscl_blank
			waitvid	metapixels, q1s
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #%%0

			mov	palptr, =@palette_area
			movd	:p_pal, #0
			mov	count, #8
:preblank1
			call #hsync
			mov	VSCL, vscl_blank
			waitvid	metapixels, q1s

			mov	pcount, #32
:pallp			rdbyte	r1, palptr
			'shl	r1, #2
			'or	r1, #3
:p_pal			mov	000, r1
			add	palptr, #1
			add	:p_pal, d0
			djnz	pcount, #:pallp

			mov	VSCL, vscl_bporch
			waitvid	metapixels, #%%0
			djnz	count, #:preblank1
			
			
			mov	count, p_pre	' 14 or 13
:preblank2
			call #hsync
			mov	VSCL, vscl_blank
			waitvid	metapixels, #0
			cmp count,#5 wz
	if_z	mov sync,linesync
	if_z	add sync,=5080*262
	if_z	wrlong	sync, =@nextvbl
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	count, #:preblank2
			
vlines		mov	ypos, #120

vline		
			' Sample a rasterline.

			call #hsync
			mov	VSCL, vscl_detach
			waitvid	metapixels, q1s
			andn VCFG,vcfg_pinmask
			
			mov r1,linesync
			sub r1,=(5080-(732))
			waitcnt r1,#0

			' We've got 4048 cycles. (ish)
			' TODO: fix potential offset

			movd	:p_st, #rasterline - 1
			mov	count, #60
:sample
			movs	:p_1, INA
:p_st			mov	rasterline, r1
:p_1			mov	r1, 000
			add	:p_st, d0
			movs	:p_2, INA
			shl	r1, #8
:p_2			or	r1, 000
			nop
			movs	:p_3, INA
			shl	r1, #8
:p_3			or	r1, 000
			nop
			movs	:p_4, INA
			shl	r1, #8
:p_4			or	r1, 000
			djnz	count, #:sample

			mov	rasterline+59, r1
			
			'mov rasterline+8, =$05050505

			' Generate a scanline.

generate			call #hsync

			mov	VSCL, vscl_fporch
			waitvid	metapixels, #0
			mov	VSCL, vscl_visible
			movd	:lp1, #rasterline
			'movd	:lp1, #testcolors
			mov	count, #60

:lp1			waitvid	000, #%%0123
			add	:lp1, d0

			djnz	count, #:lp1

			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	ypos, #vline

			mov	count, p_post		' 10 or 12
:postblank
			call #hsync
			mov	VSCL, vscl_blank
			waitvid	metapixels, #0
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	count, #:postblank

			'clkset clkreset
			jmp	#field


p_pre			long	8
p_post			long	3

hsync
				mov VSCL,#1
				waitvid metapixels,#%%11111
				andn VCFG,vcfg_pinmask
				waitcnt linesync,=5080
				mov VSCL,vscl_hsync
				nop
				waitvid metapixels,#%%3333
				or VCFG,vcfg_pinmask
				
hsync_ret		ret
				

' 3640 PLLA cycles per line (more like 3636?)
' sync width 624
' pixel width should be 12?

vscl_hsync		long	((48) << 12) | (129)	' 2 hsync metapixels, then black (was 512 cycles, but now less to make space for resync)
vscl_visible		long	((12) << 12) | (48)	' hsync + 60 * visible + bporch is one line (visible is 2880 total)
vscl_fporch		long	((48) << 12) | (235)
vscl_bporch		long	((0) << 12) | (165)
vscl_blank		long	((32) << 12) | (2880+235)	' hsync + blank + bporch is one line
vscl_blankhalf		long	((48) << 12) | (2880+235)/2	' hsync + blank + bporch is one line
vscl_detach		long	((0) << 12) | (2880+235+165)	' hsync + detach is one lines

vcfg_pinmask    long  %0111_0000
ctra_fiddlebit  long 1 << 25

metapixels		long	$7A_00_00_02		' hsync+vsync, hsync, vsync, black
'testcolors		long	$05_04_03_02

q1s			long	%%1111111111111111
q3s			long	%%3333333333333333
ntsc_frq	long    $16E8B9FC

d0			long	1 << 9
clkreset    long  $80

			pool

ypos			res	1
count			res	1
r1			res	1

palptr			res	1
pcount			res	1

sync			res	1
linesync        res 1
vcfg_testpin    res 1
measurecolor    res 1

			res	1			' Dummy word before rasterline
rasterline		res	60

			vfit	496
