			include "propeller.i"
			include "demo.i"

			org	0
PINMASK			=	$08

			mov	DIRA, #PINMASK

			' Precalc. Map from absolute y coordinate to width (as 0.32 fixed point).
			' table[y] = sqrt(1.0 - (y * y)) when y is in [0, 1]

			mov	ycount, #256
prelp
			mov	mulu_x, ycount
			sub	mulu_x, #1
			mov	mulu_s, mulu_x
			call	#mulu
			mov	log_in, =255 * 255	' 1.0 in 16.16, adjusted so the minimum log_in will be 0
			sub	log_in, mulu_s

			test	log_in, =$ff00		wz
			muxnz	exp_in, =$00080000
		if_z	shl	log_in, #8
			test	log_in, =$f000		wz
			muxnz	exp_in, =$00040000
		if_z	shl	log_in, #4
			test	log_in, =$c000		wz
			muxnz	exp_in, =$00020000
		if_z	shl	log_in, #2
			test	log_in, =$8000		wz
			muxnz	exp_in, =$00010000
		if_z	shl	log_in, #1
			shr	log_in, #3
			and	log_in, =$ffe
			add	log_in, =$c000
			rdword	log_in, log_in
			or	exp_in, log_in

			shr	exp_in, #1		' sqrt

			mov	exp_out, exp_in
			shr	exp_out, #4
			and	exp_out, =$ffe
			add	exp_out, =$d000
			rdword	exp_out, exp_out
			shl	exp_out, #15
			or	exp_out, =$80000000
			shr	exp_in, #16
			xor	exp_in, #$1f
			shr	exp_out, exp_in

			mov	t1, exp_out
			shl	t1, #24

p_dest			mov	precalc + 255, t1
			sub	p_dest, =1 << 9
			djnz	ycount, #prelp


			rdlong	r1, =@nextvbl
:w			rdlong	r2, =@nextvbl
			cmp	r1, r2			wz
		if_z	jmp	#:w

vbl
			add	expscale, =$400
			max	expscale, =$ea000

			mov	exp_in, expscale

			mov	exp_out, exp_in
			shr	exp_out, #4
			and	exp_out, =$ffe
			add	exp_out, =$d000
			rdword	exp_out, exp_out
			shl	exp_out, #15
			or	exp_out, =$80000000
			shr	exp_in, #16
			xor	exp_in, #$1f
			shr	exp_out, exp_in

			mov	scale, exp_out

			rdlong	r1, =@nextvbl
			add	r1, =0*5080+710-128

			mov	ycount, #240
vline
			mov	mulu_s, ycount
			sub	mulu_s, #120
			abs	mulu_s, mulu_s			' [0, 120]
			mov	mulu_x, scale
			mov	t1, scale
			shr	t1, #2
			sub	mulu_x, t1
			call	#mulu
			shr	mulu_s, #6
			cmp	mulu_s, #255		wc wz
		if_ae	jmp	#blank
			add	:p_fetch, mulu_s
			sub	:p_fetch, mulu_s
:p_fetch		mov	width, precalc

			mov	delta, scale
			shl	delta, #17

			neg	phase, delta
			shl	phase, #7

			mov	t1, width
			shr	t1, #1
			add	phase, t1

			mov	xcount, #256

			waitcnt	r1, =5080
xloop
			add	phase, delta
			cmp	phase, width		wc
			muxnc	OUTA, =PINMASK
			djnz	xcount, #xloop

			mov	OUTA, #0
			djnz	ycount, #vline
			jmp	#vbl
blank
			mov	xcount, #256
			waitcnt	r1, =5080
:xlp
			nop
			nop
			mov	OUTA, =PINMASK
			djnz	xcount, #:xlp

			mov	OUTA, #0
			djnz	ycount, #vline
			jmp	#vbl

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

			pool

expscale		long	$68000

r1			res	1
r2			res	1
xcount			res	1
ycount			res	1
phase			res	1
delta			res	1
width			res	1
t1			res	1
scale			res	1

divu_n			res	1
divu_d			res	1

mulu_x			res	1
mulu_s			res	1

log_in			res	1
exp_in			res	1
exp_out			res	1

precalc			res	256		' Map from absolute y coordinate to width (as 0.32 fixed point)

			vfit	496
