			include "propeller.i"
			include "demo.i"

			org	0
VUBEGIN			=	62
VUFADETIME		=	1950

			rdlong	r1, =@nextvbl
:w			rdlong	r2, =@nextvbl
			cmp	r1, r2			wz
		if_z	jmp	#:w

vbl
			rdbyte	style, =@ditherstyle
			add	style, #jumptable
			jmp	style
jumptable
			jmp	#style_2_6
			jmp	#style_8
			jmp	#style_sky
			jmp	#style_voxel
			jmp	#style_mandel
			'jmp	#style_half

style_half
			mov	bufmaster, #0
			mov	DIRA, #$0f
			mov	mask, =$0f0f0f0f
			mov	shift, #4
			mov	ycount, #128
			mov	skiplines, =(4 + 51) * 5080
			jmp	#common

style_mandel
			mov	limit, =100 + 3
			mov	bufmaster, #1
			movd	p_buf1, #frontback
			movd	p_buf2, #frontback
			mov	DIRA, #$0f
			mov	mask, =$0f0f0f0f
			mov	shift, #4
			mov	ycount, #232
			mov	skiplines, =4 * 5080
			jmp	#common

style_voxel
			mov	limit, =120 + 2
			mov	bufmaster, #1
			movd	p_buf1, #frontback_re
			movd	p_buf2, #frontback_re
			mov	DIRA, #$0f
			mov	mask, =$0f0f0f0f
			mov	shift, #4
			mov	ycount, #230
			mov	skiplines, =4 * 5080
			jmp	#common

style_sky
			mov	limit, =110 + 2
			mov	bufmaster, #1
			movd	p_buf1, #frontback_re
			movd	p_buf2, #frontback_re
			mov	DIRA, #$03
			mov	mask, =$3f3f3f3f
			mov	shift, #6
			mov	ycount, #230
			mov	skiplines, =4 * 5080
			jmp	#common

style_2_6
			mov	bufmaster, #0
			mov	DIRA, #$0f
			mov	mask, =$0f0f0f0f
			mov	shift, #4
			mov	ycount, #230		' Should actually be 232, but this makes
			mov	skiplines, =4 * 5080	' the transition ztunnel -> voxelscape smoother.
			jmp	#common

style_8
			mov	bufmaster, #0
			mov	DIRA, #$03
			mov	mask, =$3f3f3f3f
			mov	shift, #6
			mov	ycount, #232
			mov	skiplines, =4 * 5080
			'jmp	#common

common
			test	bufmaster, #1		wz
		if_z	jmp	#notmaster

			' Have the renderers completed a new buffer?

:lock			lockset	zero			wc
		if_c	jmp	#:lock

			rdword	t1, =@nextline
			cmp	t1, limit		wc wz
		if_b	jmp	#noswap

p_buf1			rol	000, #16
p_buf2			wrlong	000, =@backbuf

			wrword	zero, =@nextline
noswap
			lockclr	zero

notmaster		rdlong	r1, =@nextvbl
			add	r1, =0*5080+690

			cmp	style, #DITHER_MANDEL + jumptable	wz
		if_nz	jmp	#notmandel

			' Draw the audio visualization

			add	vuframe, #1
			cmp	vuframe, =VUBEGIN	wc wz
		if_b	jmp	#notmandel

			mov	buffer, frontback
			rol	buffer, #16
			mov	xcount, #28
:xlp
			mov	addr, buffer
			add	addr, =20 * 128 - 2
			add	addr, xcount
			add	addr, xcount
			cmp	xcount, #14		wc wz
		if_a	add	addr, #65

			rdlong	level, visualization
			sub	level, =$80000000
			abs	level, level
			sub	visualization, #4
			or	visualization, =$7f80
			movs	:p_vusc, #vulevels

			mov	ycount, #40
:ylp
:p_vusc			mov	t1, 000
			add	:p_vusc, #1
			cmp	level, t1		wc wz
		if_b	mov	t1, #0
			wrbyte	t1, addr
			add	addr, #128 * 2
			djnz	ycount, #:ylp

			djnz	xcount, #:xlp

			cmp	vuframe, =VUFADETIME	wc wz
		if_b	jmp	#:nofade

			movd	:p_fade1, #vulevels
			movd	:p_fade2, #vulevels
			mov	ycount, #40
:fadelp
:p_fade1		test	000, #$3f		wz
:p_fade2	if_nz	sub	000, #1
			add	:p_fade1, =1 << 9
			add	:p_fade2, =1 << 9
			djnz	ycount, #:fadelp
:nofade
			mov	ycount, #232

notmandel
			mov	t1, lfsr			' Fill t1 with random bits
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t2, lfsr			' Fill t2 with random bits

			and	t1, mask			' Convert t1 to four random numbers in [$00, $0f]
			and	t2, mask			' Convert t2 to four random numbers in [$00, $0f]

			rdword	addr, =@frontbuf
			wrbyte	one, =@internalvbl

			add	r1, skiplines

vline
			waitcnt	r1, =5080

			rdlong	pixels, addr
			mov	p1, pixels
			nop
			mov	xcount, #32
:xloop
			add	p1, t1				' Add the dither. No overflow between pixels possible.
			shr	p1, shift			' Shift away the dither for handy palette numbers.
			mov	OUTA, p1
			mov	p2, pixels
			add	p2, t2				' Add the dither. No overflow between pixels possible.
			shr	p2, shift			' Shift away the dither for handy palette numbers.
			mov	OUTA, p2
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
			shr	lfsr, #1		wc	' Run the lfsr
			mov	OUTA, p1
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t1, lfsr			' Fill t1 with random bits
			and	t1, mask			' Convert t1 to four random numbers in [$00, $0f]
			mov	OUTA, p2
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
			shr	lfsr, #1		wc	' Run the lfsr
			mov	OUTA, p1
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t2, lfsr			' Fill t2 with random bits
			and	t2, mask			' Convert t2 to four random numbers in [$00, $0f]
			mov	OUTA, p2
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
			add	addr, #4
			mov	OUTA, p1
			rdlong	pixels, addr
			mov	p1, pixels
			mov	OUTA, p2
			djnz	xcount, #:xloop

			test	ycount, #1		wz
		if_z	sub	addr, #128
			djnz	ycount, #vline

			mov	OUTA, #0
			jmp	#vbl

one			long	1
lfsr			long	1
taps			long	$c0000031

frontback		word	@graphics0, @graphics1
frontback_re		word	@graphics0r, @graphics1r

visualization		long	$7ffc

vulevels
			long	$3c000064
			long	$39000063
			long	$36000062
			long	$33000061
			long	$30000060
			long	$2d00005f
			long	$2a00005e
			long	$2700005d
			long	$2400005c
			long	$2100005b
			long	$1e00005a
			long	$1b000059
			long	$18000058
			long	$15000057
			long	$12000056
			long	$0f000055
			long	$0c000054
			long	$09000053
			long	$06000052
			long	$03000051
			long	$03000051
			long	$06000052
			long	$09000053
			long	$0c000054
			long	$0f000055
			long	$12000056
			long	$15000057
			long	$18000058
			long	$1b000059
			long	$1e00005a
			long	$2100005b
			long	$2400005c
			long	$2700005d
			long	$2a00005e
			long	$2d00005f
			long	$30000060
			long	$33000061
			long	$36000062
			long	$39000063
			long	$3c000064

			pool

vuframe			long	0

r1			res	1
r2			res	1
xcount			res	1
ycount			res	1
addr			res	1
pixels			res	1
t1			res	1
t2			res	1
p1			res	1
p2			res	1
style			res	1
mask			res	1
shift			res	1
bufmaster		res	1
limit			res	1
buffer			res	1
level			res	1
skiplines		res	1

			vfit	496
